#ifndef _BL_H_
#define _BL_H_

#ifdef OLDGCC
/* 
 * a bug in the gcc port -- it doesn't save %a4, as it isn't 
 * supposed to be destroyed; SysTraps() however do this casually;
 * place these macros in EventHandler routines and callback functions.
 *
 * the egcs port doesn't have it anymore :-)
 */
register void *reg_a4 asm("%a4");
#  define CALLBACK_PROLOGUE \
    void *save_a4 = reg_a4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);
#  define CALLBACK_EPILOGUE reg_a4 = save_a4;
#else
#  define CALLBACK_PROLOGUE
#  define CALLBACK_EPILOGUE
#endif

/*
 * distinguish v1.x from v2.x headers
  */
#ifdef sysAppLaunchCmdHandleSyncCallApp
# define FrmSetObjectPositon FrmSetObjectPosition
# define PrefGetAppPreferences PrefGetAppPreferencesV10
# define PrefSetAppPreferences PrefSetAppPreferencesV10
# define SelectDay(a,b,c,d) SelectDay(selectDayByDay,a,b,c,d)
#endif
  

/*
 * definitions from bl.c
 */

typedef struct {
  UInt Version;
  Short matchDay;
  Short NumTeams;
  Short Spieltage;
  Byte options;
# define twoPoints  1
} BlDatabasePreferencesType;

typedef struct {
  Int Version;
  LocalID dbID;
  UInt cardNo;
  Byte options;
# define editMode   1
# define dontSaveEM 2
  ULong dbHash[20];
} BlApplicationPreferencesType;

typedef struct {
  Byte whenPointsHandicap;
  char pointsHandicap;
  Byte whenGoalsHandicap;
  char goalsHandicap;
} HandicapType;

extern char team[20][18];
extern Word programme[520];
extern Word results[520];
extern ULong Datum[52];
extern HandicapType handicap[20];
extern Short DBNr;
extern SystemPreferencesType sysPrefs;
extern BlApplicationPreferencesType appPrefs;
extern BlDatabasePreferencesType prefs;

typedef struct {
  Byte Tore, GTore, Pkte, Spiele, Platz, HSpiele;
  Byte Gew, HGew, Rem, HRem, Ver, HVer, HTore, HGTore, HPkte;
  long Index;
} MannStatus;
extern MannStatus MStatus[];

extern Short matchDay;

VoidPtr Id2Ptr(Word);
void BerechneTabelle();
void FrmMoveObject(Int, Int, Int);
CharPtr M1vSpNr(Word);
CharPtr M2vSpNr(Word);
void DrawBegegnungen(Boolean);
ListPtr FrmGetListPtr(Word frm, Word id);
Boolean hasHandicap();

/*
 * definitions from dbfuncs.c
 */
typedef struct {
  LocalID dbID;
  UInt cardNo;
  Char dbName[32];
  UInt dbAttr;
} SelectedDBInfo;

extern CharPtr Items[];
extern Short nrOfItems;

DmOpenRef CreateDatabase(CharPtr);
Err ReadDatabase(DmOpenRef);
Err OpenDatabase(UInt, LocalID);
void SaveStatus(Short);
Short FindInstalledDatabases();
void ChooseDB();
void SelectedDB(Short, SelectedDBInfo*);
void InitNewDatabase(DmOpenRef,BlDatabasePreferencesType*);
void DeleteDatabase(Short);
Boolean RenameDatabase(Short i, CharPtr name);
void swapDbInfo(int, int);


/*
 * definitions from edit.c
 */
void InitFormEdit();
Boolean EditFormHandleEvent(EventPtr);
void InitFormTeams();
Boolean TeamsFormHandleEvent(EventPtr);
Boolean EnterMannFormHandleEvent(EventPtr);
Boolean NewDBFormHandleEvent(EventPtr);
Boolean RenameLeagueFormHandleEvent(EventPtr);
Boolean SettingsFormHandleEvent(EventPtr);
Boolean HandicapFormHandleEvent(EventPtr e);
Boolean LeagueFormHandleEvent(EventPtr e);

/*
 * extra localization not handled in bl.rcp
 */
#if defined(ENGLISH)
#  define CHOOSE_DATE "Choose Date"
#  define H_WON  "W"
#  define H_DRAW "D"
#  define H_LOST "L"
#  define A_WON  "w"
#  define A_DRAW "d"
#  define A_LOST "l"
#elif defined(ESPANIOL)
#  define CHOOSE_DATE "Escoge Fecha"
#  define H_WON  "G"
#  define H_DRAW "E"
#  define H_LOST "P"
#  define A_WON  "g"
#  define A_DRAW "e"
#  define A_LOST "p"
#elif defined(PORTUGUES)
#  define CHOOSE_DATE "Escolha Rodada"
#  define H_WON  "V"
#  define H_DRAW "E"
#  define H_LOST "D"
#  define A_WON  "v"
#  define A_DRAW "e"
#  define A_LOST "d"
#elif defined(FRENCH)
#  define CHOOSE_DATE "Choix Date"
#  define H_WON  "G"
#  define H_DRAW "N"
#  define H_LOST "P"
#  define A_WON  "g"
#  define A_DRAW "n"
#  define A_LOST "p"
#else
#  define H_WON  "G"
#  define H_DRAW "U"
#  define H_LOST "V"
#  define A_WON  "g"
#  define A_DRAW "u"
#  define A_LOST "v"
#  define CHOOSE_DATE "Datum whlen"
#endif

#endif
